# Set environment variables for creating your own Image. All are required.
# This Script has been adapted from the the original hadoop-env.sh
# Prepared: Chandra Sekhar Pedamallu
#
#
##########################################################EDIT THE FOLLOWING VARIABLES#####################################
# Import variables
bin=`dirname "$0"`
bin=`cd "$bin"; pwd`
. "$bin"/cluster.config
#. ./cluster.config
echo $bin

# Your Amazon Account Number. (Edit)
AWS_ACCOUNT_ID=$AWS_ACCOUNTID

# Your Amazon AWS access key. (Edit)
AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEYID

# Your Amazon AWS secret access key. (Edit)
AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESSKEY

# Location of EC2 keys. (Edit)
# The default setting is probably OK if you set up EC2 following the Amazon Getting Started guide.
EC2_KEYDIR=$EC2KEYDIR

#Repeat masker is available (Edit)
#REP_AVAIL="Y"
#REP_LOC="/xchip/pasteur/chandra/Amazon/hadoop-0.20.2/src/contrib/ec2/bin/test"
#REP_LIB="repeatmaskerlibraries-20090604.tar.gz"
#REP_DIS="distrib.tar.Z"

REP_AVAIL=$REPAVAIL
REP_LIB=$REPBASELOC
REP_DIS=$CROSSMATCHLOC


# The EC2 key name used to launch instances. (Edit)
# The default is the value used in the Amazon Getting Started guide.
KEY_NAME=$KEYNAME


# The Amazon S3 bucket where the Hadoop AMI is stored. [Edit]
# The default value is for public images, so can be left if you are using running a public image.
# Change this value only if you are creating your own (private) AMI
# so you can store it in a bucket you own.
#S3_BUCKET=ami-tmp
S3_BUCKET=$IMAGEBUCKET

# The EC2 instance type: m1.small, m1.large, m1.xlarge (Edit)
INSTANCE_TYPE=$INSTANCETYPE
##########################################################END OF EDITING VARIABLES#####################################

##########################################################DON'T EDIT THE FOLLOWING VARIABLES#####################################

# Base image of Pathseq(DON'T EDIT)
BASE_IMG="ami-f034c399"


# Where your EC2 private key is stored (created when following the Amazon Getting Started guide).
# You need to change this if you don't store this with your other EC2 keys.
PRIVATE_KEY_PATH=`echo "$EC2_KEYDIR"/"id-$KEY_NAME"`

# SSH options used when connecting to EC2 instances.
SSH_OPTS=`echo -i "$PRIVATE_KEY_PATH" -o StrictHostKeyChecking=no -o ServerAliveInterval=30`

# The version of Hadoop to use.
HADOOP_VERSION=0.19.0

# Enable public access to JobTracker and TaskTracker web interfaces
ENABLE_WEB_PORTS=true

# The script to run on instance boot.
USER_DATA_FILE=hadoop-ec2-init-remote.sh


# The EC2 group master name. CLUSTER is set by calling scripts
CLUSTER_MASTER=$CLUSTER-master

# Cached values for a given cluster
MASTER_PRIVATE_IP_PATH=~/.hadooop-private-$CLUSTER_MASTER
MASTER_IP_PATH=~/.hadooop-$CLUSTER_MASTER
MASTER_ZONE_PATH=~/.hadooop-zone-$CLUSTER_MASTER

#
# The following variables are only used when creating an AMI.
#

# The version number of the installed JDK.
JAVA_VERSION=1.6.0_21

# SUPPORTED_ARCHITECTURES = ['i386', 'x86_64']
# The download URL for the Sun JDK. Visit http://java.sun.com/javase/downloads/index.jsp and get the URL for the "Linux self-extracting file".
if [ "$INSTANCE_TYPE" == "m1.small" -o "$INSTANCE_TYPE" == "c1.medium" ]; then
  ARCH='i386'
  BASE_AMI_IMAGE="ami-2b5fba42"  # ec2-public-images/fedora-8-i386-base-v1.07.manifest.xml
  JAVA_BINARY_URL=''
else
  ARCH='x86_64' 
  BASE_AMI_IMAGE="ami-2a5fba43"  # ec2-public-images/fedora-8-x86_64-base-v1.07.manifest.xml
  JAVA_BINARY_URL=''
fi

if [ "$INSTANCE_TYPE" == "c1.medium" ]; then
  AMI_KERNEL=aki-9b00e5f2 # ec2-public-images/vmlinuz-2.6.18-xenU-ec2-v1.0.i386.aki.manifest.xml
fi

if [ "$INSTANCE_TYPE" == "c1.xlarge" ]; then
  AMI_KERNEL=aki-9800e5f1 # ec2-public-images/vmlinuz-2.6.18-xenU-ec2-v1.0.x86_64.aki.manifest.xml
fi

if [ "$AMI_KERNEL" != "" ]; then
  KERNEL_ARG="--kernel ${AMI_KERNEL}"
fi

#########################################################DON'T EDIT THE FOLLOWING VARIABLES#####################################
