/*
	Author: Chandra Sekhar Pedamallu
	Description: This program is meant remove reads that are more than 20 at a given position

	Input:<reads file> <threshold> 
	
	Output: 
	 outfile("Output");

	Commandline: ./remove_positions <referencegene> <gene_expression>

	Updates:
	none
	
*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include<stdio.h>
#include<fstream>
#include<iostream>
#include<vector>
#include<time.h>

using namespace std;
const int no_put=10;
char* trim(char *str){
	 char* cp;
	while(*str && strchr(" \n\r\t", *str)!=NULL)
		str++;
	cp=str+strlen(str)-1;
	while(cp>str && strchr(" \n\r\t", *cp)!=NULL)
		*cp-- = '\0';
	return str;
}

int main(int argc, char* argv[]){
	time_t start, end;
	time(&start); // Start time
	//printf("%s\n", "Start");
if(argc < 3){
	cout<<"please include reference name and snp name"<<endl;
	cout<<"./gname_snp <reference file> <snpfile>"<<endl;
	exit(0);	
}
// read reads in FQ1
	ifstream fin(argv[1]);
	vector<string> read;
	string line;
	int no_line=0;
	if(fin.is_open()){
		while(!fin.eof()){
			getline(fin, line);
			if(line.size()>0){
				//cout<<line<<endl;
				char *str;
				str=new char[line.size()+1];
				strcpy(str, line.c_str());
				char *strtemp = trim(str);
				if(strlen(strtemp)>0){
					read.push_back(line);
					no_line++;
				}
			}
		}
	}
	cout<<no_line<<" "<<read.size()<<endl;
	fin.close();
// End of reference gene

// read reads in Blast output
	ifstream bfin(argv[2]);
	char *str = argv[3];
	ofstream outfile(str);
	string bline;
	if(bfin.is_open()){
		int blinec=0;
		while(!bfin.eof()){
			getline(bfin, bline);
			if(bline.size()>0){
				char *bstr;
				bstr=new char[bline.size()+1];
				strcpy(bstr, bline.c_str());
				char *bstrtemp = trim(bstr);
				if(strlen(bstrtemp)>0){
					char *bp;
					int bcount=0;
					bp=strtok(bstr, "\t");
					while(bp!=NULL){
						bp=strtok(NULL,"\t");
						bcount++;
					}
					if(bcount>2){
						outfile<<read.at(blinec)<<endl;
					}
					blinec++;				
				}
			}
		}
	}
	fin.close();
	
	outfile.close();

	time(&end);
	double dif=difftime(end, start); // End time
	cout<<"Time"<<dif<<endl;

	return 0;
}
