#!/usr/bin/env python

# Data loader.py
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: Data loader from FTP servers or S3 bucket
# Notes: S3 bucket is not available for this version
# DFCI @ copyright

import sys
import os
import commands
import random
import re


# config file download
nconfignum=random.randint(0, 1000000)
nconfig=str(nconfignum)

# Download config file from hadoop file system 
wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/config /usr/local/" + nconfig
wget=commands.getstatusoutput(wget1)
print wget

ref=""
namefile="/usr/local/" + nconfig
ff = open(namefile, 'r')
data = ff.readlines()
ref=data[5].strip()
ff.close()
	
print ref
print "Hello"

ref=ref + "-tmp"

# Downloading the reference
print "Downloading ........................hs_4genomics.bfa"
#ssh1="/usr/bin/s3cmd -f -c /root/.s3cfg get -r s3://ami-ref/ /mnt/mfiles/ref/"
ssh1="/usr/bin/s3cmd -f -c /root/.s3cfg get -r s3://" + ref
#ssh1=ssh1 + ref
ssh1=ssh1 + "/ /mnt/mfiles/ref/"
print ssh1
ssh=commands.getoutput(ssh1)
print ssh

#virus_all.fasta.tar.gz
print "Unzip.......................virus_all.fasta.tar.gz"
ssh1="/bin/tar -xvzf /mnt/mfiles/ref/virus_all.fasta.tar.gz -C /mnt/mfiles/ref/"
ssh=commands.getoutput(ssh1)
print ssh

#fungi_all.fasta.tar.gz
print "Unzip.......................fungi_all.fasta.tar.gz"
ssh1="/bin/tar -xvzf /mnt/mfiles/ref/fungi_all.fasta.tar.gz -C /mnt/mfiles/ref/"
ssh=commands.getoutput(ssh1)
print ssh

#all_bacterial.fna.tar.gz
print "Unzip.......................all_bacterial.fna.tar.gz"
ssh1="/bin/tar -xvzf /mnt/mfiles/ref/all_bacterial.fna.tar.gz -C /mnt/mfiles/ref/"
ssh=commands.getoutput(ssh1)
print ssh

#formatdb for virus_all.fasta 
print " creating refcontig blastable database viral.db"
fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/virus_all.fasta\" -n /mnt/mfiles/ref/viral.db -p F"
fbd=commands.getoutput(fdb1)  
print fbd

#formatdb for all.bacterial.fna 
print " creating refcontig blastable database viral.db"
fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/all_bacterial.fna\" -n /mnt/mfiles/ref/bacterial.db -p F"
fbd=commands.getoutput(fdb1)  
print fbd

#formatdb for Fungi_all.fasta 
print " creating refcontig blastable database viral.db"
fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/fungi_all.fasta\" -n /mnt/mfiles/ref/fungi.db -p F"
fbd=commands.getoutput(fdb1)  
print fbd

#virus_protein_db.fasta.tar.gz
print "Unzip.......................virus_protein_db.fasta.tar.gz"
ssh1="/bin/tar -xvzf /mnt/mfiles/ref/virus_protein_db.fasta.tar.gz -C /mnt/mfiles/ref/"
ssh=commands.getoutput(ssh1)
print ssh

#formatdb for fungus_protein_db.fasta 
print " creating refcontig blastable database viral_protein.db"
fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/virus_protein_db.fasta\" -n /mnt/mfiles/ref/virus_protein.db -p T"
fbd=commands.getoutput(fdb1)  
print fbd

#Fungus_protein_db.fasta.tar.gz
print "Unzip.......................Fungus_protein_db.fasta.tar.gz"
ssh1="/bin/tar -xvzf /mnt/mfiles/ref/fungus_protein_db.fasta.tar.gz -C /mnt/mfiles/ref/"
ssh=commands.getoutput(ssh1)
print ssh

#formatdb for fungus_protein_db.fasta 
print " creating refcontig blastable database viral.db"
fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/fungus_protein_db.fasta\" -n /mnt/mfiles/ref/fungus_protein.db -p T"
fbd=commands.getoutput(fdb1)  
print fbd

