/*
	Created: Chandra Sekhar Pedamallu
	Usage: extract unmapped reads
	Input file: Database file in Fasta

	Copyright@DFCI, BroadInst.
*/

import java.util.*;
import java.io.*;


public class extractUnmapped_latest{


	public static void main(String args[]){

		try{
			//Blast Hit Table file
			FileReader fr=new FileReader(args[0]);
			BufferedReader br=new BufferedReader(fr);

			double thres_eval=Double.parseDouble(args[1]);

			Vector vctmp=new Vector();
			String pervious="NOTHING";
			Hashtable hashtable = new Hashtable();
			String readname="";
			String record=new String();
			while((record=br.readLine()) != null){
				String rec = record.trim();
				StringTokenizer stt=new StringTokenizer(rec, "\t");
				int no=0;
				int f_bindex=0; int f_beindex=0;
				int no_tokens=stt.countTokens();
				while(stt.hasMoreElements()){
					String token=stt.nextToken();
					if(no==0){
						readname=token;
						f_bindex=0;
						f_beindex=0;
					}
					else if(no==2){
						int no_blast=Integer.parseInt(token.toString());
						if(no_blast==1){
							f_bindex=1;
						}
					}
					else if(no==8){
						double Eval=Double.parseDouble(token.toString());
						if((f_bindex==1) && (Eval <= thres_eval)){
							f_beindex=1;
							//System.out.println(readname+" "+f_bindex+" "+Eval);
						}
					}
					else if(no==(no_tokens-1)){
						if(f_beindex==1){
							if((readname.equals(pervious))||pervious.equals("NOTHING")){
								vctmp.addElement(token);
								pervious=readname;
							}
							else{
								Vector vctmp1=new Vector();
								for(int kk=0; kk<vctmp.size(); kk++){
									vctmp1.addElement(vctmp.get(kk).toString());
								}
								hashtable.put(pervious, vctmp1);

								vctmp.clear();
								vctmp.addElement(token);
								pervious=readname;

							}
							//System.out.println(readname+" "+f_beindex+" "+token);
						}
					}
					no++;
				}
			}

			Vector vctmp1=new Vector();
			for(int kk=0; kk<vctmp.size(); kk++){
				vctmp1.addElement(vctmp.get(kk).toString());
			}
			hashtable.put(pervious, vctmp1);

			fr.close();
			vctmp.clear();
			System.out.println(hashtable.size());

			FileReader fr1=new FileReader(args[2]);
			BufferedReader br1=new BufferedReader(fr1);
			BufferedWriter out=new BufferedWriter(new FileWriter(args[3]));

			String record1=new String();
			while((record1=br1.readLine()) != null){
				String rec = record1.trim();
				StringTokenizer stt=new StringTokenizer(rec, "\t");
				int no=0;
				int found=0;
				Vector tmp=new Vector();
				while(stt.hasMoreElements()){
					String token=stt.nextToken().toString();
					// Check whether the reads names are the same.
					if(no==0){
						if( hashtable.containsKey(token)){
							tmp=(Vector)hashtable.get(token);
							found=1;
						}
						else{
							out.write(rec);
							out.write("\n");
						}
					}
					/*else if(no == 1){
						if(found==1){
							int avail=0;
							String tmp1="";
							for(int l=0; l<tmp.size(); l++){
								tmp1=tmp.get(l).toString();
								if(token.indexOf(tmp1) >= 0){
									avail=1;
									break;
								}

							}
							if((found==1) && (avail==0)){
								System.out.println(rec+" "+tmp1);

							}
							if(avail==0){
								System.out.println(rec);
							}

						}
						else{

							System.out.println(rec);
						}
					}*/
					no++;
				}

			}
			fr1.close();
			out.close();
		}catch(Exception e){System.out.println(e);}
	}
}
