#!/usr/bin/env python

# Data loader.py
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: Data loader from FTP servers or S3 bucket
# Notes: S3 bucket is not available for this version
# DFCI @ copyright

import sys
import os
import commands
import random
import re


ssh1="/bin/rm -r /mnt/mfiles/reads"
ssh=commands.getoutput(ssh1)

ssh1="/bin/rm -r /mnt/mfiles/ref"
ssh=commands.getoutput(ssh1)

	
ssh1="/bin/mkdir /mnt/mfiles"
ssh=commands.getoutput(ssh1)
	
ssh1="mount /dev/sdb /mnt/mfiles"
ssh=commands.getoutput(ssh1)

ssh1="/bin/rm -r /mnt/mfiles/reads"
ssh=commands.getoutput(ssh1)

ssh1="/bin/rm -r /mnt/mfiles/ref"
ssh=commands.getoutput(ssh1)
                        
ssh1="/bin/mkdir /mnt/mfiles/ref"
ssh=commands.getoutput(ssh1)   
			
ssh1="/bin/mkdir /mnt/mfiles/reads"
ssh=commands.getoutput(ssh1)   

# config file download
nconfignum=random.randint(0, 1000000)
nconfig=str(nconfignum)

# Download config file contigs s3 bucket information from hadoop file system 
wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/config /usr/local/" + nconfig
wget=commands.getstatusoutput(wget1)
print wget

# Download database list downloaded
wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/Complete.database /usr/local/lst.database"
wget=commands.getstatusoutput(wget1)
print wget

# Download s3config file from hadoop file system 
wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/s3config/.s3cfg /root/.s3cfg" 
wget=commands.getstatusoutput(wget1)
print wget

# Reference genome location
ref=""
namefile="/usr/local/" + nconfig
ff = open(namefile, 'r')
data = ff.readlines()
ref=data[5].strip()
ff.close()
print ref

# Genome location
namefile="/usr/local/lst.database"
ff = open(namefile, 'r')
data = ff.readlines()
no=data[0].strip()
ff.close()

maqdb_names=open("/usr/local/maq.db", 'w')
blastdb_names=open("/usr/local/blast.db", 'w')

for n in range(0, int(no)):
	database=data[n+1].strip()
	
	data_split=database.split("/")
	name_file=""
	for token in data_split:
		name_file=token

	print name_file

	print "Downloading....................databases"
	ssh1="/usr/bin/s3cmd -f -c /root/.s3cfg get -r " + database
	ssh1=ssh1 + " /mnt/mfiles/ref/"
	ssh1=ssh1 + name_file
	ssh=commands.getoutput(ssh1)
	
	print "Contents in Zip file"
	ssh1="/bin/tar -ztf /mnt/mfiles/ref/" + name_file
	ssh=commands.getoutput(ssh1)
	file_name=ssh

	print "Unzip.......................database"
	ssh1="/bin/tar -xvzf /mnt/mfiles/ref/" + name_file
	ssh1= ssh1 + " -C /mnt/mfiles/ref/"
	ssh=commands.getoutput(ssh1)
	print ssh
	print file_name[:3]
	
	if file_name[:3]=="Maq":
		maqdb_names.write(file_name)
		maqdb_names.write("\n")

	elif file_name[:3]=="Bla":
		
		blastdb_names.write(file_name)
		blastdb_names.write("\n")
		print "megablast database "
		fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/"
		fdb1=fdb1 + file_name
		fdb1=fdb1 + "\" -n /mnt/mfiles/ref/"
		fdb1=fdb1 + file_name
		fdb1=fdb1 + " -p F -o T -v 10000"
		fbd=commands.getoutput(fdb1)  
		print fbd
	
	elif file_name[:3]=="MAQ":
		maqdb_names.write(file_name)
		maqdb_names.write("\n")

	elif file_name[:3]=="BLA":
		blastdb_names.write(file_name)
		blastdb_names.write("\n")
		print "megablast database "
		fdb1="/root/blast-2.2.23/bin/formatdb -i \"/mnt/mfiles/ref/"
		fdb1=fdb1 + file_name
		fdb1=fdb1 + "\" -n /mnt/mfiles/ref/"
		fdb1=fdb1 + file_name
		fdb1=fdb1 + " -p F -o T -v 10000"
		fbd=commands.getoutput(fdb1)  
		print fbd
	
blastdb_names.close()
maqdb_names.close()



ssh1="/bin/rm /mnt/mfiles/ref/*.tar.gz"
ssh=commands.getoutput(ssh1)


wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -put /usr/local/maq.db /user/root/config/"
wget=commands.getstatusoutput(wget1)
print wget

wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -put /usr/local/blast.db /user/root/config/"
wget=commands.getstatusoutput(wget1)
print wget
