#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI, The Broad Inst.
# Purpose: mapper jobs for Maq alignments
# Notes: S3 bucket is not available for this version
# Updates: Removed Quality Filter
#          Added duplicate remover at the begining 
# DFCI @ copyright

import sys
import os
import commands
import random

#input comes from STDIN
for line in sys.stdin:
        # Strip off spaces infornt and behing the lines
        line = line.strip()
        print line
        tokens=line.split("/")
        name1=""
        for token in tokens:
                name1=token
        print name1
        tokens1=name1.split(".")
        print tokens1
        j=0
        for token in tokens1:
                j=j+1

        print j
        j=j-1
        j1=0
        name=""
        for token in tokens1:
                if j1==0:
                        name=name + token
                elif j1==j:
                        print "test"
                else:
                        name=name + "."
                        name=name + token
                j1=j1+1

        print name
	# config file download
	nconfignum=random.randint(0, 1000000)
	nconfig=str(nconfignum)

        # Download config file from hadoop file system 
	wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/config /usr/local/" + nconfig
        wget=commands.getstatusoutput(wget1)
        print wget
        
	# Download maq database file from hadoop file system 
	wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/maq.db /usr/local/" + nconfig
	wget1= wget1 + ".maq.db"
        wget=commands.getstatusoutput(wget1)
        print wget

        # read config file from hadoop file system 
	#ami-test-output
	#ami-test-stat
	#ami-test-repeati
	#ami-test-repeato
	#ami-test-foutput
	
	output=""
	stat=""
	namefile="/usr/local/" + nconfig
	ff = open(namefile, 'r')
	data = ff.readlines()
	output=data[0].strip()
        stat=data[1].strip()
	ff.close()

	name_fi="/usr/local/" + nconfig
	name_fi=name_fi + ".maq.db"
	ff = open(name_fi, 'r')
	database = ff.readlines()
	ff.close()
	no_databases=len(database)



        # Wget the SAM files from FTP server
	wget1="/usr/bin/s3cmd -f -c /root/.s3cfg get -r " + line
	wget1=wget1 + " /mnt/mfiles/reads/"
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"
        
	# Wget the SAM files from FTP server
	wget1="/bin/gunzip /mnt/mfiles/reads/" + name1
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"

        #File names
        fFASTQ=name
        fSAM=name + ".sam"
        fQSAM=fSAM + ".sam"
        fFQ1=name + ".fq1"
        fBFQ=name + ".bfq"
        fUmap=name + ".nr"
        fOut=name + ".out"
	fDUP1=name + ".dup"
	fDUP=fDUP1 + ".fq1"
        fSORT1=name + ".sorted"
        fSORT=fSORT1 + ".fq1"	

	# filenames of statistics
        sINT=name + ".stat.int"
        sDUP=name + ".stat.dup"
        sDB=name + ".stat.mdb"

	#Duplicate remover
        #Step 1: Duplicate remover
        #Step 1a. Convert FASTQ2FQ1 - Compile Java file
        FASTQ2FQ1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        FASTQ2FQ1=FASTQ2FQ1 + "Fastq2FQone.java"
        FASTQ2FQ1c=commands.getstatusoutput(FASTQ2FQ1)
        print FASTQ2FQ1c

        #Step1b. Convert FASTQ2FQ1
        FASTQ2FQ1="/usr/local/jdk1.6.0_21/bin/java -classpath . Fastq2FQone /mnt/mfiles/reads/" + fFASTQ
        FASTQ2FQ1=FASTQ2FQ1 + " /mnt/mfiles/reads/"
        FASTQ2FQ1=FASTQ2FQ1 + fFQ1
        FASTQ2FQ1c=commands.getstatusoutput(FASTQ2FQ1);
        print FASTQ2FQ1c

        #Step1c. Sorting the FQ1 file
	print "SORTING"
	SORT1="/bin/sort +1 -2 -T /mnt/mfiles /mnt/mfiles/reads/" + fFQ1
        SORT1=SORT1 + " > /mnt/mfiles/reads/"
        SORT1=SORT1 + fSORT
        SORT=commands.getstatusoutput(SORT1);
        print SORT
        
	#Before Duplicate remover - STATISTICS
	print "Statistics before duplicate remover"
	STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fSORT
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sINT
        STAT=commands.getstatusoutput(STAT1);
        print STAT
        
	#Upload the Statistics of reads before duplicate remover
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sINT
        out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
	
	#Step1d. Duplicate remover
	DUP1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	DUP1=DUP1 + "*.java"
	DUP=commands.getstatusoutput(DUP1);
	print DUP

	#Step1e. Run duplicate remover
	DUP1="/usr/local/jdk1.6.0_21/bin/java -classpath . removeduplicates_new /mnt/mfiles/reads/" + fSORT
	DUP1=DUP1 + " /mnt/mfiles/reads/"
	DUP1=DUP1 + fFQ1
	print DUP1
	DUP=commands.getstatusoutput(DUP1);
	print DUP
	print "completed"
	
        #STATISTICS - AFTER DUPLICATE REMOVER
        STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sDUP
        STAT=commands.getstatusoutput(STAT1);
        print STAT

	#Upload the Statistics of reads after duplicate remover
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sDUP
        out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
        
	#Step 1f. Remove temporaryfiles from duplicate remover
        #RM1="/bin/rm -f /mnt/mfiles/reads/" + fSORT
        #RM=commands.getstatusoutput(RM1);
        #print RM
	
	#Step 1g. Convert FQ1 to FASTQ -compile
        FQ12FASTQ="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        FQ12FASTQ=FQ12FASTQ + "FQone2Fastq.java"
        FQ12FASTQc=commands.getstatusoutput(FQ12FASTQ)
        print FQ12FASTQc

        #Step1b. Convert FQ12FASTQ
        FQ12FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . FQone2Fastq /mnt/mfiles/reads/" + fFQ1
        FQ12FASTQ=FQ12FASTQ + " /mnt/mfiles/reads/"
        FQ12FASTQ=FQ12FASTQ + fFASTQ
        FQ12FASTQc=commands.getstatusoutput(FQ12FASTQ);
        print FQ12FASTQc

############Running Maq alignments#####################################################
	for dbindex in range(0, int(no_databases)):
		database_name= database[dbindex].strip()
		
		#Step 4: FASTQ to BFQ
		FASTQ2BFQ="/usr/local/bin/maq fastq2bfq /mnt/mfiles/reads/" + fFASTQ
		FASTQ2BFQ=FASTQ2BFQ + " /mnt/mfiles/reads/"
		FASTQ2BFQ=FASTQ2BFQ + fBFQ
		FASTQ2BFQc=commands.getstatusoutput(FASTQ2BFQ)
		print FASTQ2BFQc

		#Step 5 : Blast against databases

		#Step 5a. Run the MAQ alignment on each database
		MAQ="/usr/local/bin/maq map -u /mnt/mfiles/reads/" + fUmap
		MAQ=MAQ + " /mnt/mfiles/reads/"
		MAQ=MAQ + fOut
		MAQ=MAQ + " /mnt/mfiles/ref/"
		MAQ=MAQ + database_name
		MAQ=MAQ + " /mnt/mfiles/reads/"
		MAQ=MAQ + fBFQ
		MAQc=commands.getstatusoutput(MAQ);
		#print maq

		#Step 5b. compile MAQunmapped 2 FASTQ
		MAQ2FASTQ="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		MAQ2FASTQ=MAQ2FASTQ + "MAQunmapped2fastq.java"
		MAQ2FASTQc=commands.getstatusoutput(MAQ2FASTQ)
		#print MAQ2FASTQc

		#Step 5c. Convert Unmapped reads MAQunmapped 2 FASTQ
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . MAQunmapped2fastq /mnt/mfiles/reads/" + fUmap
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFASTQ
		Un2FASTQc=commands.getstatusoutput(Un2FASTQ);
		print Un2FASTQc

		# compile Java files
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "MAQunmapped2FQone.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1
		
		# Convert Unmapped reads MAQunmapped 2 FQ1
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . MAQunmapped2FQone /mnt/mfiles/reads/" + fUmap
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFQ1
		p6=commands.getstatusoutput(Un2FASTQ);
		print p6		

		#STATISTICS - AFTER DB1
		STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
		STAT1=STAT1 + " > /mnt/mfiles/reads/"
		STAT1=STAT1 + sDB
		STAT1=STAT1 + str((dbindex+1))
		STAT=commands.getstatusoutput(STAT1);
		print STAT

		#Upload the Statistics of reads after DB1
		out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sDB
		out1=out1 + str((dbindex+1))
		out1=out1 + " s3://"
		out1=out1 + stat
		out1=out1 + "/"	
		print out1
		out=commands.getstatusoutput(out1)


#################################################################
        
	#Upload the unmapped reads
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fFQ1
        out1=out1 + " s3://"
	out1=out1 + output
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
