#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: mapper repeatmasker jobs
# Updates: Added multiple database parts
# DFCI @ copyright

import sys
import os
import commands
import random

#input comes from STDIN
for line in sys.stdin:
        # Strip off spaces infornt and behing the lines
        line = line.strip()
        print line
        tokens=line.split("/")
        name=""
        for token in tokens:
                name=token
        print name

        # config file download
        nconfignum=random.randint(0, 1000000)
        nconfig=str(nconfignum)

        # Download config file from hadoop file system
        wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/config /usr/local/" + nconfig
        wget=commands.getstatusoutput(wget1)
        print wget

	# Download maq database file from hadoop file system 
	wget1="/usr/local/hadoop-0.19.0/bin/hadoop fs -get /user/root/config/blast.db /usr/local/" + nconfig
	wget1= wget1 + ".blast.db"
        wget=commands.getstatusoutput(wget1)
        print wget

        # read config file from hadoop file system
        repeato=""
        stat=""
        namefile="/usr/local/" + nconfig
        ff = open(namefile, 'r')
        data = ff.readlines()
        repeato=data[3].strip()
        stat=data[1].strip()
        ff.close()
        
	name_fi="/usr/local/" + nconfig
	name_fi=name_fi + ".blast.db"
	ff = open(name_fi, 'r')
	database = ff.readlines()
	ff.close()
	no_databases=len(database)        
   
        # Wget the SAM files from FTP server
        wget1="/usr/bin/s3cmd -f -c /root/.s3cfg get " + line
        wget1=wget1 + " /mnt/mfiles/reads/"
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"

        #File names
        fFQ=name
        fFASTA=name + ".fasta"
        fREPEAT=fFASTA + ".masked"
        fUREPEAT=name + ".U.fq1"
        fOUT=name + ".OUT"
        fOUT1=name + ".OUT1"
	fMEGA=name
	fBLASTN=name + "bn.fq1"

	# filenames of statistics
	sREP=name + ".stat.arep"
	sMEG=name + ".stat.MEG"
	sBLA=name + ".stat.BLA"


        #RepeatMaskerFormat.java
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "RepeatMaskerFormat.java"
        REPF=commands.getstatusoutput(REPF1)
        print REPF

        # Convert Unmapped reads RepeatMasker FQ1 2 FASTA
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . RepeatMaskerFormat /mnt/mfiles/reads/" + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFASTA
        FQ12FASTA=FQ12FASTA + " FQ1"
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6

        #Step 1: REPEATMASKER
        MASK1="/usr/local/RepeatMasker/RepeatMasker -pa 4 /mnt/mfiles/reads/" + fFASTA
        print MASK1
        p6=commands.getstatusoutput(MASK1);
        print p6
        
	# Find repeatmasker file
	Mfile1="/mnt/mfiles/reads/" + fREPEAT
	Mfile=os.path.exists(Mfile1)
	print Mfile

	if Mfile:   # Masked file is present
	
		#Convert Repeatmaskerread.java file
	        pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	        pp1f1=pp1f1 + "RepeatMaskerRead.java"
	        p1f2=commands.getstatusoutput(pp1f1)
        	print pp1f1

	        #Remove the sequence with more N's
        	REPEAT1="/usr/local/jdk1.6.0_21/bin/java -classpath . RepeatMaskerRead /mnt/mfiles/reads/" + fREPEAT
	        REPEAT1=REPEAT1 + " /mnt/mfiles/reads/"
        	REPEAT1=REPEAT1 + fFQ
	        REPEAT1=REPEAT1 + " /mnt/mfiles/reads/"
        	REPEAT1=REPEAT1 + fUREPEAT
	        REPEAT1=REPEAT1 + " 2"
        	p6=commands.getstatusoutput(REPEAT1);
	        print p6

	else:	# no masking present
		COPY1="/bin/cp /mnt/mfiles/reads/" + fFQ
		COPY1=COPY1 + " /mnt/mfiles/reads/"
		COPY1=COPY1 + fUREPEAT
		p6=commands.getstatusoutput(COPY1);
                print p6

###############################################################################
	number_reads=0
	
	# Megablast jobs
	for dbindex in range(0, int(no_databases)):
		database_name= database[dbindex].strip()
		
		#RepeatMaskerFormat.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "RepeatMaskerFormat.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		# Convert Unmapped reads  FQ1 2 FASTA
		FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . RepeatMaskerFormat /mnt/mfiles/reads/" + fUREPEAT
		FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
		FQ12FASTA=FQ12FASTA + fFASTA
		FQ12FASTA=FQ12FASTA + " FQ1"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6
		
		if dbindex == 0:
			#AFTER REPEAT MASKER  - STATISTICS
			print "Statistics after REPEATMASKER"
			STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
			STAT1=STAT1 + " | wc -l"
			STAT1=STAT1 + " > /mnt/mfiles/reads/"
			STAT1=STAT1 + sREP
			STAT=commands.getstatusoutput(STAT1);
			print STAT

			#Upload the Statistics of reads After repeatmasker
			out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sREP
			out1=out1 + " s3://"
			out1=out1 + stat
			out1=out1 + "/"
			print out1
			out=commands.getstatusoutput(out1)
		else :

			#AFTER MEGABLAST  - STATISTICS
			print "Statistics after Megablast"
			STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
			STAT1=STAT1 + " | wc -l"
			STAT1=STAT1 + " > /mnt/mfiles/reads/"
			STAT1=STAT1 + sMEG
			STAT1=STAT1 + str(dbindex)
			STAT=commands.getstatusoutput(STAT1);
			print STAT

			#Upload the Statistics of reads After MEGABlast
			out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sMEG
			out1=out1 + str(dbindex)
			#out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + str(dbindex)
			#out1=out1 + "."
			#out1=out1 + sMEG
			out1=out1 + " s3://"
			out1=out1 + stat
			out1=out1 + "/"
			print out1
			out=commands.getstatusoutput(out1)

		# Check No reads
		FQ12FASTA="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
		FQ12FASTA=FQ12FASTA + " | wc -l"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6

		number_reads=int(p6[1])
		if number_reads == 0:
			break			
		
		# Megablast on reads over all.rnaAndCdna.fasta
		print "MEGABlast"
		mega1="/root/blast-2.2.23/bin/megablast -i /mnt/mfiles/reads/" + fFASTA	
		mega1=mega1 + " -d \"/mnt/mfiles/ref/"
		mega1=mega1 + database_name
		mega1=mega1 + "\" -a 4 -D 2 -e 0.0000001 -W 16 -b 0 -v 5 -f -F F -o /mnt/mfiles/reads/"
		mega1=mega1 + fOUT
		print mega1
		p6=commands.getstatusoutput(mega1);
		print p6

		#BlastParser.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "BlastParser.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		# Convert BLASTPARSER BLASTOUTPUT 2 OUTTMP
		BLASTP1="/usr/local/jdk1.6.0_21/bin/java -classpath . BlastParser /mnt/mfiles/reads/" + fOUT
		BLASTP1=BLASTP1 + " /mnt/mfiles/reads/"
		BLASTP1=BLASTP1 + fOUT1
		p6=commands.getstatusoutput(BLASTP1);
		print p6

		# g++ ParsedBlastParser.cc
		CC1="/usr/bin/g++ ParsedBlastParser.cc -o ParsedBlastParser"
		print CC1
		p6=commands.getstatusoutput(CC1);
		print p6

		# Run ParsedBlastParser.cc
		CC1="./ParsedBlastParser /mnt/mfiles/reads/" + fUREPEAT
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fOUT1
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fMEGA
		p6=commands.getstatusoutput(CC1);
		print p6

		# Copy the fMEGA to fUREPEAT for next run
		CC1="/bin/cp /mnt/mfiles/reads/" + fMEGA
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fUREPEAT
		p6=commands.getstatusoutput(CC1);
		print p6



	# BlastN jobs
	
	for dbindex in range(0, int(no_databases)):
		database_name= database[dbindex].strip()
		
		#RepeatMaskerFormat.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "RepeatMaskerFormat.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		# Convert Unmapped reads  FQ1 2 FASTA
		FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . RepeatMaskerFormat /mnt/mfiles/reads/" + fUREPEAT
		FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
		FQ12FASTA=FQ12FASTA + fFASTA
		FQ12FASTA=FQ12FASTA + " FQ1"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6
		
		if dbindex == 0:
			#AFTER MEGABLAST  - STATISTICS
			print "Statistics after Megablast"
			STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
			STAT1=STAT1 + " | wc -l"
			STAT1=STAT1 + " > /mnt/mfiles/reads/"
			STAT1=STAT1 + sMEG
			STAT1=STAT1 + str(no_databases)
			STAT=commands.getstatusoutput(STAT1);
			print STAT

			#Upload the Statistics of reads After MEGABlast
			out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sMEG
			out1=out1 + str(no_databases)
			#out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + str(no_databases)
			#out1=out1 + "."
			#out1=out1 + sMEG
			out1=out1 + " s3://"
			out1=out1 + stat
			out1=out1 + "/"
			print out1
			out=commands.getstatusoutput(out1)
		else :
			#AFTER BLASTN1  - STATISTICS
			print "Statistics after Megablast"
			STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
			STAT1=STAT1 + " | wc -l"
			STAT1=STAT1 + " > /mnt/mfiles/reads/"
			STAT1=STAT1 + sBLA
			STAT1=STAT1 + str(dbindex)
			STAT=commands.getstatusoutput(STAT1);
			print STAT

			#Upload the Statistics of reads After BLASTN1
			out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sBLA
			out1=out1 + str(dbindex)
			out1=out1 + " s3://"
			out1=out1 + stat
			out1=out1 + "/"
			print out1
			out=commands.getstatusoutput(out1)


		# Check No reads
		FQ12FASTA="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
		FQ12FASTA=FQ12FASTA + " | wc -l"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6

		number_reads=int(p6[1])
		if number_reads == 0:
			break			
		
		

		mega1="/root/blast-2.2.23/bin/blastall -p blastn -i /mnt/mfiles/reads/" + fFASTA	
		mega1=mega1 + " -d \"/mnt/mfiles/ref/"
		mega1=mega1 + database_name
		mega1=mega1 + "\" -e 0.0000001 -W 7 -r 1 -q -3 -G 5 -E 2 -F F -a 4 -b 0 -v 5 -o /mnt/mfiles/reads/"
		mega1=mega1 + fOUT
		print mega1
		p6=commands.getstatusoutput(mega1);
		print p6

		#BlastParser.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "BlastParser.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		# Convert BLASTPARSER BLASTOUTPUT 2 OUTTMP
		BLASTP1="/usr/local/jdk1.6.0_21/bin/java -classpath . BlastParser /mnt/mfiles/reads/" + fOUT
		BLASTP1=BLASTP1 + " /mnt/mfiles/reads/"
		BLASTP1=BLASTP1 + fOUT1
		p6=commands.getstatusoutput(BLASTP1);
		print p6

		# g++ ParsedBlastParser.cc
		CC1="/usr/bin/g++ ParsedBlastParser.cc -o ParsedBlastParser"
		print CC1
		p6=commands.getstatusoutput(CC1);
		print p6

		# Run ParsedBlastParser.cc
		CC1="./ParsedBlastParser /mnt/mfiles/reads/" + fUREPEAT
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fOUT1
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fMEGA
		p6=commands.getstatusoutput(CC1);
		print p6

		# Copy the fMEGA to fUREPEAT for next run
		CC1="/bin/cp /mnt/mfiles/reads/" + fMEGA
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fUREPEAT
		p6=commands.getstatusoutput(CC1);
		print p6
		
     
	#AFTER BLASTN2  - STATISTICS
	print "Statistics after Megablast"
	STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fUREPEAT
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sBLA
	STAT1=STAT1 + str(no_databases)
	STAT=commands.getstatusoutput(STAT1);
	print STAT

	#Upload the Statistics of reads After BlastN2
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sBLA
	out1=out1 + str(no_databases)
	out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
	print out1
	out=commands.getstatusoutput(out1)


	#Upload the unmapped reads
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fUREPEAT
	out1=out1 + " s3://"
	out1=out1 + repeato
	out1=out1 + "/"
	print out1
	out=commands.getstatusoutput(out1)
