#! /bin/bash
# Count the numbers and create a HTML pages for output
HTML_out=$1
stat_dir=$2
statfolder=$3
aftermaq=$4
aftercomp=$5
afterpostsub=$6
aftervpostsub=$7
velvetfolder=$8


# Creation of directory
/bin/mkdir $stat_dir

#Download statistics files from s3://ami-stat
/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$statfolder/ $stat_dir

#Download sequence files after Maq alignment 
#/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$aftermaq/ $stat_dir

#cat $stat_dir/*.fq1  > UnmappedAfterMaq.fq1.seq

#rm $stat_dir/*.fq1

#Download sequence files After computational subtraction
/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$aftercomp/ $stat_dir
/usr/bin/find $stat_dir -name "*.fq1" -print | xargs cat >> $stat_dir/UnmappedAfterCompSub.fq1.seq
/usr/bin/find $stat_dir -name "*.fq1" | xargs rm

#cat $stat_dir/*.fq1  > $stat_dir/UnmappedAfterCompSub.fq1.seq
#rm $stat_dir/*.fq1

#Download contigs.fq1
/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$velvetfolder/ $stat_dir
/usr/bin/find $stat_dir -name "*.fq1" -print | xargs cat >> $stat_dir/velvet_contigs.seq
/usr/bin/find $stat_dir -name "*.fq1" | xargs rm
#cat $stat_dir/*.fq1  > $stat_dir/velvet_contigs.seq
#rm $stat_dir/*.fq1



#Hit tables, Unmapped for Human, Fungi, bacterial, Viral Hit table
/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$afterpostsub/ $stat_dir
/usr/bin/s3cmd -f -c /root/.s3cfg get -r --force s3://$aftervpostsub/ $stat_dir


#  Hit table from reads
/usr/bin/find $stat_dir -name "*.bacterial.HitTable" -print | xargs cat >> $stat_dir/MEGA_Unmapped_RAM_bacterial
/usr/bin/find $stat_dir -name "*.all.blastN.HitTable" -print | xargs cat >> $stat_dir/BlastN_Unmapped_All
/usr/bin/find $stat_dir -name "*.fungal.viral.blastX.HitTable" -print | xargs cat >> $stat_dir/BlastX_Unmapped_VF

#cat $stat_dir/*.bacterial.HitTable  > $stat_dir/MEGA_Unmapped_RAM_bacterial
#cat $stat_dir/*.all.blastN.HitTable  > $stat_dir/BlastN_Unmapped_All
#cat $stat_dir/*.fungal.viral.blastX.HitTable > $stat_dir/BlastX_Unmapped_VF

# Unmapped reads from postsubstraction
/usr/bin/find $stat_dir -name "*.bacterial.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedreads_MEGA_bacterial.seq
/usr/bin/find $stat_dir -name "*.blastn.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedreads_BLASTN.seq
/usr/bin/find $stat_dir -name "*.blastx.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedreads_BLASTX.seq

#cat $stat_dir/*.bacterial.unmapped.fq1 > $stat_dir/Unmappedreads_MEGA_bacterial.seq
#cat $stat_dir/*.blastn.unmapped.fq1 > $stat_dir/Unmappedreads_BLASTN.seq
#cat $stat_dir/*.blastx.unmapped.fq1 > $stat_dir/Unmappedreads_BLASTX.seq


#  Hit table from contigs
/usr/bin/find $stat_dir -name "*.vbacterial.HitTable" -print | xargs cat >> $stat_dir/MEGA_VContig_RAM_bacterial
/usr/bin/find $stat_dir -name "*.vall.blastN.HitTable" -print | xargs cat >> $stat_dir/BlastN_VContig_All
/usr/bin/find $stat_dir -name "*.vfungal.viral.blastX.HitTable" -print | xargs cat >> $stat_dir/BlastX_VContig_VF

#cat $stat_dir/*.vbacterial.HitTable > $stat_dir/MEGA_VContig_RAM_bacterial
#cat $stat_dir/*.vall.blastN.HitTable > $stat_dir/BlastN_VContig_All
#cat $stat_dir/*.vfungal.viral.blastX.HitTable > $stat_dir/BlastX_VContig_VF

# Unmapped contigs from postsubstraction
/usr/bin/find $stat_dir -name "*.vbacterial.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedcontigs_MEGA_bacterial.seq
/usr/bin/find $stat_dir -name "*.vall.blastN.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedcontigs_BLASTN.seq
/usr/bin/find $stat_dir -name "*.vfungal.viral.blastX.unmapped.fq1" -print | xargs cat >> $stat_dir/Unmappedcontigs_BLASTX.seq

#cat $stat_dir/*.vbacterial.unmapped.fq1 > $stat_dir/Unmappedcontigs_MEGA_bacterial.seq
#cat $stat_dir/*.vall.blastN.unmapped.fq1 > $stat_dir/Unmappedcontigs_BLASTN.seq
#cat $stat_dir/*.vfungal.viral.blastX.unmapped.fq1 > $stat_dir/Unmappedcontigs_BLASTX.seq
/usr/bin/find $stat_dir -name "*.fq1" | xargs rm

#rm $stat_dir/*.fq1

#move reads into your format
#mv UnmappedAfterMaq.fq1.seq UnmappedAfterMaq.fq1
mv $stat_dir/UnmappedAfterCompSub.fq1.seq $stat_dir/UnmappedAfterCompSub.fq1
mv $stat_dir/velvet_contigs.seq $stat_dir/contigs.fq1

mv $stat_dir/Unmappedreads_MEGA_bacterial.seq $stat_dir/Unmappedreads_MEGA_bacterial.fq1
mv $stat_dir/Unmappedreads_BLASTN.seq $stat_dir/Unmappedreads_BLASTN.fq1
mv $stat_dir/Unmappedreads_BLASTX.seq $stat_dir/Unmappedreads_BLASTX.fq1

mv $stat_dir/Unmappedcontigs_MEGA_bacterial.seq $stat_dir/Unmappedcontigs_MEGA_bacterial.fq1
mv $stat_dir/Unmappedcontigs_BLASTN.seq $stat_dir/Unmappedcontigs_BLASTN.fq1
mv $stat_dir/Unmappedcontigs_BLASTX.seq $stat_dir/Unmappedcontigs_BLASTX.fq1


/usr/bin/find $stat_dir -name "*.HitTable" | xargs rm
#rm $stat_dir/*.HitTable
mv $stat_dir/MEGA_Unmapped_RAM_bacterial $stat_dir/MEGA_Unmapped_RAM_bacterial.HitTable
mv $stat_dir/BlastN_Unmapped_All $stat_dir/BlastN_Unmapped_All.HitTable
mv $stat_dir/BlastX_Unmapped_VF $stat_dir/BlastX_Unmapped_VF.HitTable

mv $stat_dir/MEGA_VContig_RAM_bacterial $stat_dir/MEGA_VContig_RAM_bacterial.HitTable
mv $stat_dir/BlastN_VContig_All $stat_dir/BlastN_VContig_All.HitTable
mv $stat_dir/BlastX_VContig_VF $stat_dir/BlastX_VContig_VF.HitTable

echo "running RAM tools"

/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ *.java

/usr/local/jdk1.6.0_21/bin/java -classpath /root/ RunRAM $stat_dir/MEGA_Unmapped_RAM_bacterial.HitTable $stat_dir/MEGA_Unmapped_RAM_bacterial.RAM /mnt/mfiles/ref/complete_microbial_genomes_list_ncbi_condensed.txt 

/usr/local/jdk1.6.0_21/bin/java -classpath /root/ RunRAM $stat_dir/MEGA_VContig_RAM_bacterial.HitTable $stat_dir/MEGA_VContig_RAM_bacterial.RAM /mnt/mfiles/ref/complete_microbial_genomes_list_ncbi_condensed.txt 

# Initial reads
/usr/bin/find $stat_dir -name "*.int" -print | xargs cat >> $stat_dir/initial.stat
/usr/bin/find $stat_dir -name "*.int" | xargs rm
initial_reads=`/bin/awk -f statistics.awk T0=$stat_dir/initial.stat < empty.awk`

# After Duplicate reads
/usr/bin/find $stat_dir -name "*.dup" -print | xargs cat >> $stat_dir/duplicate.stat
/usr/bin/find $stat_dir -name "*.dup" | xargs rm
adup_reads=`/bin/awk -f statistics.awk T0=$stat_dir/duplicate.stat < empty.awk`

# After Maq1 reads
/usr/bin/find $stat_dir -name "*.mdb1" -print | xargs cat >> $stat_dir/maqdb1.stat
/usr/bin/find $stat_dir -name "*.mdb1" | xargs rm
maqdb1_reads=`/bin/awk -f statistics.awk T0=$stat_dir/maqdb1.stat < empty.awk`

# After Maq2 reads
/usr/bin/find $stat_dir -name "*.mdb2" -print | xargs cat >> $stat_dir/maqdb2.stat
/usr/bin/find $stat_dir -name "*.mdb2" | xargs rm
maqdb2_reads=`/bin/awk -f statistics.awk T0=$stat_dir/maqdb2.stat < empty.awk`

# After Maq3 reads
/usr/bin/find $stat_dir -name "*.mdb3" -print | xargs cat >> $stat_dir/maqdb3.stat
/usr/bin/find $stat_dir -name "*.mdb3" | xargs rm
maqdb3_reads=`/bin/awk -f statistics.awk T0=$stat_dir/maqdb3.stat < empty.awk`

# After Maq4 reads
/usr/bin/find $stat_dir -name "*.mdb4" -print | xargs cat >> $stat_dir/maqdb4.stat
/usr/bin/find $stat_dir -name "*.mdb4" | xargs rm
maqdb4_reads=`/bin/awk -f statistics.awk T0=$stat_dir/maqdb4.stat < empty.awk`

# After repeatmasker reads
/usr/bin/find $stat_dir -name "*.arep" -print | xargs cat >> $stat_dir/arepeat.stat
/usr/bin/find $stat_dir -name "*.arep" | xargs rm
arep_reads=`/bin/awk -f statistics.awk T0=$stat_dir/arepeat.stat < empty.awk`

# After MEGABLAST1 reads
/usr/bin/find $stat_dir -name "*.MEG1" -print | xargs cat >> $stat_dir/ameg1.stat
/usr/bin/find $stat_dir -name "*.MEG1" | xargs rm
ameg1_reads=`/bin/awk -f statistics.awk T0=$stat_dir/ameg1.stat < empty.awk`

# After MEGABLAST2 reads
/usr/bin/find $stat_dir -name "*.MEG2" -print | xargs cat >> $stat_dir/ameg2.stat
/usr/bin/find $stat_dir -name "*.MEG2" | xargs rm
ameg2_reads=`/bin/awk -f statistics.awk T0=$stat_dir/ameg2.stat < empty.awk`

# After BLASTN1 reads
/usr/bin/find $stat_dir -name "*.BLA1" -print | xargs cat >> $stat_dir/abla1.stat
/usr/bin/find $stat_dir -name "*.BLA1" | xargs rm
abla1_reads=`/bin/awk -f statistics.awk T0=$stat_dir/abla1.stat < empty.awk`

# After BLASTN2 reads
/usr/bin/find $stat_dir -name "*.BLA2" -print | xargs cat >> $stat_dir/abla2.stat
/usr/bin/find $stat_dir -name "*.BLA2" | xargs rm
abla2_reads=`/bin/awk -f statistics.awk T0=$stat_dir/abla2.stat < empty.awk`

echo "<HTML>" > $HTML_out
echo "<body bgcolor=lightyellow>" >> $HTML_out

echo "<b>Results summary: </b> <br> <br>" >> $HTML_out
echo "<Table border="1">" >> $HTML_out

echo "<TR BGCOLOR=#99CCFF>" >> $HTML_out
echo "<TD><b>Substraction</b></TD><TD><b>Pathseq_Cloud</b></TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of reads </b></TD><TD>" >> $HTML_out
echo $initial_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out


echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of reads after duplicate remover </b></TD><TD>" >> $HTML_out
echo $adup_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Maq 1 alignment (Database: MAQ1) </b></TD><TD>" >> $HTML_out
echo $maqdb1_reads >> $HTML_out 
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Maq 2 alignment (Database: MAQ2) </b></TD><TD>" >> $HTML_out
echo $maqdb2_reads >> $HTML_out 
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Maq 3 alignment (Database: MAQ3) </b></TD><TD>" >> $HTML_out
echo $maqdb3_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Maq 4 alignment (Database: MAQ4) </b></TD><TD>" >> $HTML_out
echo $maqdb4_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after repeat masker </b></TD><TD>" >> $HTML_out
echo $arep_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Megablast (Database: BLAST1) </b></TD><TD>" >> $HTML_out
echo $ameg1_reads  >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after Megablast (Database: BLAST2) </b></TD><TD>" >> $HTML_out
echo $ameg2_reads  >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after BlastN1 (Database: BLAST1) </b></TD><TD>" >> $HTML_out
echo $abla1_reads >> $HTML_out
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads after BlastN2 (Database: BLAST2) </b></TD><TD>" >> $HTML_out
echo $abla2_reads >> $HTML_out 
echo "</TD></TR>" >> $HTML_out

echo "<TR>" >> $HTML_out
echo "<TD><b>Total number of unmapped reads </b></TD><TD>" >> $HTML_out
echo $abla2_reads >> $HTML_out 
echo "</TD></TR>" >> $HTML_out

echo "<TR BGCOLOR=lightgreen>" >> $HTML_out
echo "<TD><b>Reads after computational subtraction (Unmapped reads)</b></TD><TD><a href=UnmappedAfterCompSub.fq1 target=_blank>unmappedreads.fq1</a>" >> $HTML_out
echo "</TD></TR>" >> $HTML_out
echo "<TR BGCOLOR=lightgreen>" >> $HTML_out
echo "<TD><b>Contigs from unmapped reads</b></TD><TD><a href=contigs.fq1 target=_blank>contigs.fq1</a>" >> $HTML_out
echo "</TD></TR>" >> $HTML_out
echo "</TABLE>" >> $HTML_out

echo "<br>" >> $HTML_out
echo "<br>" >> $HTML_out

echo "<Table border=1>" >> $HTML_out
echo "<TR BGCOLOR=#99CCFF><TD><b>Post-substraction results</b></TD><TD><b>Unmapped reads</b></TD><TD><b>Contigs</b></TD></TR>" >> $HTML_out
echo "<TR><TD><b>BlastN</b></TD><TD><a href=BlastN_Unmapped_All.HitTable>Hit table</a></TD><TD><a href=BlastN_VContig_All.HitTable>Hit Table </a></TD></TR>" >> $HTML_out
echo "<TR><TD><b>BlastX</b></TD><TD><a href=BlastX_Unmapped_VF.HitTable>Hit table</a></TD><TD><a href=BlastX_VContig_VF.HitTable>Hit Table </a></TD></TR>" >> $HTML_out
echo "<TR><TD><b>RAM results</b></TD><TD><a href=MEGA_Unmapped_RAM_bacterial.HitTable>Hit table</a></TD><TD><a href=MEGA_VContig_RAM_bacterial.HitTable>Hit Table </a></TD></TR>" >> $HTML_out
echo "</TABLE>" >> $HTML_out
echo "<br>" >> $HTML_out
echo "<br>" >> $HTML_out

echo "<Table border=1>" >> $HTML_out
echo "<TR BGCOLOR=#99CCFF><TD><b>Unmapped reads after post-substractioni (> 1E-10)</b></TD><TD><b>Unmapped reads</b></TD><TD><b>Contigs</b></TD></TR>" >> $HTML_out
echo "<TR><TD><b>BLASTN</b></TD><TD><a href=Unmappedreads_BLASTN.fq1>Unmapped reads</a></TD><TD><a href=Unmappedcontigs_BLASTN.fq1>Unmapped contigs </a></TD></TR>" >> $HTML_out
echo "<TR><TD><b>BLASTX</b></TD><TD><a href=Unmappedreads_BLASTX.fq1>Unmapped reads</a></TD><TD><a href=Unmappedcontigs_BLASTX.fq1>Unmapped contigs </a></TD></TR>" >> $HTML_out
echo "<TR><TD><b>RAM results</b></TD><TD><a href=Unmappedreads_MEGA_bacterial.fq1>Unmapped reads</a></TD><TD><a href=Unmappedcontigs_MEGA_bacterial.fq1>Unmapped reads </a></TD></TR>" >> $HTML_out
echo "</TABLE>" >> $HTML_out

echo "<br>" >> $HTML_out
echo "<br>" >> $HTML_out


echo "<br><b>Databases:</b><br>" >> $HTML_out
echo "MAQ1:Genome Project female reference database (updated: 5/17/2010)<br>" >> $HTML_out
echo "MAQ2:Esembl Homosapiens cDNA database (updated: 1/2/2011)<br>" >> $HTML_out
echo "MAQ3:Human genome and transcriptome database (Updated: 2/17/2011)<br>" >> $HTML_out
echo "MAQ4:set of 3 assembled human genomes (Updated: 11/22/2010)<br>" >> $HTML_out
echo "MEGA:NCBI Homosapiens RNA database and cDNA (Updated: 11/22/2010) + Human ref contigs (Updated: 2/1/2011)<br>" >> $HTML_out
echo "BLAST1:NCBI Homosapiens RNA database and cDNA (Updated: 11/22/2010)<br>" >> $HTML_out
echo "BLAST2:Human ref contig (Updated: 2/1/2011)<br><br>" >> $HTML_out
echo "<b>Program versions:</b><br>" >> $HTML_out
echo "Maq aligner: version 0.7.1<br>" >> $HTML_out
echo "Repeatmasker: version open-3.2.8<br>" >> $HTML_out
echo "Repeatmasker libraries: dated 2009/06/04<br>" >> $HTML_out
echo "Blast Tools: version 2.2.23<br>" >> $HTML_out

echo "</body>" >> $HTML_out
echo "</HTML>" >> $HTML_out

/usr/bin/find $stat_dir -name "*.stat" | xargs rm
#/bin/rm $stat_dir/*.stat


echo "tar -cvf Output.tar UnmappedAfterMaq.fq1 UnmappedAfterCompSub.fq1 $HTML_out"
/bin/cp $HTML_out $stat_dir/$HTML_out
cd $stat_dir


tar -cvf Output.tar contigs.fq1 UnmappedAfterCompSub.fq1 MEGA_Unmapped_RAM_bacterial.HitTable BlastN_Unmapped_All.HitTable BlastX_Unmapped_VF.HitTable MEGA_VContig_RAM_bacterial.HitTable BlastN_VContig_All.HitTable BlastX_VContig_VF.HitTable Unmappedreads_MEGA_bacterial.fq1 Unmappedreads_BLASTN.fq1 Unmappedreads_BLASTX.fq1 Unmappedcontigs_MEGA_bacterial.fq1 Unmappedcontigs_BLASTN.fq1 Unmappedcontigs_BLASTX.fq1 $HTML_out
